;Assemble with:
;
;yasm x86_32bit_paging_lib.asm -o x86_32bit_paging_lib.bin
;nasm x86_32bit_paging_lib.asm -o x86_32bit_paging_lib.bin



;List of paging functions:
;;
 ;OPCODE__CPU_x86_32_raw_paging_allocate_physical_4KB_page      (should be capable to initialize our kernel page directory all by itself)
 ;OPCODE__CPU_x86_32_remap_physical_page_address
 ;OPCODE__CPU_x86_32_map_physical_pagedir_entry
 ;OPCODE__CPU_x86_32_addr2pagedirent
 ;OPCODE__CPU_Disable_Default_Paging
 ;OPCODE__CPU_Enable_Default_Paging
 ;OPCODE__CPU_load_CR3_paging
 ;OPCODE__CPU_generate_4KB_empty_page_directory


;List of raw memory functions:
;;
 ;OPCODE__detect_32bit_memory_by_pages    (must be called before any memory allocation)
 ;kalloc_Append_Kernel_Pages



;List of raw binary data functions:
;;
 ;OPCODE__binary_data__find_first_free_WIDEWORD


;List of bitmap functions:
;;
 ;OPCODE__data_bitmap__get_free_bits_offsets
 ;OPCODE__data_bitmap_offset_to_4K_address
 ;OPCODE__data_bitmap__get_free_physical_memory_address



;List of VGA card functions:
;;
 ;VGAVideo_CRTC_setTextCurPos



;List of string functions:
;;
 ;num2str



;List of mode 03h text functions:
;;
 ;console_scroll_update
 ;console_doCRLFeffect
 ;console_kprint_visible
 ;console_kprint_uint32_16



;List of debug macros:
;;
 ;printdbg_str_hexnum String_Name,"String to display: ",0,wideax   (last 2 parameters are string terminator and value to display)
 ;include_debugstr String_Name,"FunctionName"  (to mark function starts in assembled code)
 %define isdbg 1       ;Set flag to 0 to disable producing debugging code


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
KERN_START:
%xdefine KERNEL_BASE 1048576


;Data for test assembly in 32-bit mode:
;;
bits 32
org KERNEL_BASE
























































































;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;INIT: x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)



;v2019-05-06 (Mon)
;v2019-04-26 (Fri)
;v2019-04-23 (Tue)

;Using privileged CLI/STI to enable interrupts only when
;needed, and otherwise keep them off for maximum speed
;is something we would like to achieve transparently
;for system code, but not do for application code,
;so we also define privileged instructions like ...WIDE
;instructions that are portable across privilege levels.
;;
 %ifndef _x86_Portable__LEVEL_
  %ixdefine _x86_Portable__LEVEL_ 0  ;0 system, 1 user
 %endif


;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation
;;;;INIT: Documentation


;Automatic size selection for data/variables:
;-------------------------------------------------------------------------
;wideword            -- Automatic size selection, 2, 4 or 8 bytes.
;ww                  -- Automatic size selection, define wideword, 2, 4 or 8 bytes.
;wideword_SZ         -- Automatic size selection, 2, 4 or 8 bytes.
;wideword_SZ_nibbles -- Number of nibbles (4-bit groups) in the native wideword.
;wideword_SZ_BitRotationMultiply -- Number of left-shifts that give the number of bits in a wideword.
; %ixdefine wideword_SZ 2
; %ixdefine wideword_SZ_nibbles 4
; %ixdefine wideword_bits 16
; %ixdefine wideword_bits_BitRotationMultiply 4
; %ixdefine wideword_bits_mask 1111B
; %ixdefine wideword_SZ_BitRotationMultiply 1
; %ixdefine wideword_MSB 1000000000000000b
; %ixdefine wideword_MSN 1111000000000000b
; %ixdefine wideword_LSN 0000000000001111b




;Automatic size selection for any on-stack call return addresses:
;-------------------------------------------------------------------------
;_CALL_STACK_ADDR_SZ_ -- 2, 4 or 8 bytes.




;Automatic size selection for CPU registers:
;-------------------------------------------------------------------------
;wideax -- 2, 4 or 8 bytes.
;widebx -- 2, 4 or 8 bytes.
;widecx -- 2, 4 or 8 bytes.
;widedx -- 2, 4 or 8 bytes.
;widesi -- 2, 4 or 8 bytes.
;widedi -- 2, 4 or 8 bytes.
;widesp -- 2, 4 or 8 bytes.
;widebp -- 2, 4 or 8 bytes.




;Automatic size selection for "Address" and "Operand" prefixes:
;-------------------------------------------------------------------------
;awide -- a16, a32 or nothing.
;owide -- a16, a32 or nothing.




;Automatic size selection for CPU instructions:
;-------------------------------------------------------------------------
;cmpswide -- 2, 4 or 8 bytes.
;lodswide -- 2, 4 or 8 bytes.
;stoswide -- 2, 4 or 8 bytes.
;movswide -- 2, 4 or 8 bytes.
;inswide  -- 2 or 4 bytes.
;outswide -- 2 or 4 bytes.
;retwide  -- 2, 4 or 8 byte POPs for return addresses.
;End_retwide -- 2, 4 or 8 byte POPs for return addresses (marks end of routine for documentation).
;iretwide -- 2, 4 or 8 byte POPs for return addresses.
;End_iretwide -- 2, 4 or 8 byte POPs for return addresses (marks end of routine for documentation).



;Automatic variable or register selection for 64-bit CPU r8-r9 registers:
;-------------------------------------------------------------------------
;_r8  -- 2, 4 or 8 bytes.
;_r9  -- 2, 4 or 8 bytes.
;_r10 -- 2, 4 or 8 bytes.
;_r11 -- 2, 4 or 8 bytes.
;_r12 -- 2, 4 or 8 bytes.
;_r13 -- 2, 4 or 8 bytes.
;_r14 -- 2, 4 or 8 bytes.
;_r15 -- 2, 4 or 8 bytes.




;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation
;;;;END:  Documentation

;Common units/sizes
;;
 GB equ 1048576*1048576
 MB equ 1048576



;The reason why we don't use numbers like 8086 for 16-bit code
;and 386 for 32-bit code is that this source file is size-oriented
;and we want to indicate the actual machine word size, not just
;the base CPU.
;
;Indicating the CPU as a number might work and be better when we are
;dealing with CPU-oriented code. The fact of naming the CPUs with numbers
;was a very optimizing thinking from people at Intel, so CPUs can be
;directly identified and named in the CPU instructions themselves
;and in software by defining pure numbers.
;
;Set the default mode of x86 Portable to work under
;16-bit Unreal Mode (with access to 4 GB of address space):
;;
 %ifndef _x86_Portable__PLATFORMBITS_
  %ixdefine _x86_Portable__PLATFORMBITS_ 1632
 %endif


x86_Portable_START:

;Include a JMP instruction so that we can include this source file
;anywhere in a NASM/YASM assembly source code without causing failures
;due to the embedded data bytes here:
;;
 align 16
 jmp x86_Portable_END
 align 16

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%if _x86_Portable__PLATFORMBITS_==16     ;16-bit 8086 code

 %ixdefine _CALL_STACK_ADDR_SZ_ 2

 %ixdefine wideword    word
 %ixdefine ww          dw
 %ixdefine wideword_SZ 2
 %ixdefine wideword_SZ_nibbles 4
 %ixdefine wideword_bits 16
 %ixdefine wideword_bits_BitRotationMultiply 4
 %ixdefine wideword_bits_mask 1111B
 %ixdefine wideword_SZ_BitRotationMultiply 1
 %ixdefine wideword_MSB 1000000000000000b
 %ixdefine wideword_MSN 1111000000000000b
 %ixdefine wideword_LSN 0000000000001111b

 %ixdefine wideax    ax
 %ixdefine widecx    cx
 %ixdefine widedx    dx
 %ixdefine widebx    bx
 %ixdefine widesp    sp
 %ixdefine widebp    bp
 %ixdefine widesi    si
 %ixdefine widedi    di

 %ixdefine _r8       word[__r8]
 %ixdefine _r9       word[__r9]
 %ixdefine _r10      word[__r10]
 %ixdefine _r11      word[__r11]
 %ixdefine _r12      word[__r12]
 %ixdefine _r13      word[__r13]
 %ixdefine _r14      word[__r14]
 %ixdefine _r15      word[__r15]

 __r8  dw 0
 __r9  dw 0
 __r10 dw 0
 __r11 dw 0
 __r12 dw 0
 __r13 dw 0
 __r14 dw 0
 __r15 dw 0


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushf
 %ixdefine popfwide  popf
 %ixdefine cmpswide  cmpsw
 %ixdefine lodswide  lodsw
 %ixdefine stoswide  stosw
 %ixdefine movswide  movsw
 %ixdefine inswide   insw
 %ixdefine outswide  outsw
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_ret16"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iret
 %macro End_iretwide 0
 iret
 db "End_iret16"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push ax
 %ixdefine push_widesi push si

 %ixdefine pop_wideax pop ax
 %ixdefine pop_widesi pop si

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==1632   ;16-bit Unreal Mode

 %ixdefine _CALL_STACK_ADDR_SZ_ 2

 %ixdefine wideword    dword
 %ixdefine ww          dd
 %ixdefine wideword_SZ 4
 %ixdefine wideword_SZ_nibbles 8
 %ixdefine wideword_bits 32
 %ixdefine wideword_bits_BitRotationMultiply 5
 %ixdefine wideword_bits_mask 11111B
 %ixdefine wideword_SZ_BitRotationMultiply 2
 %ixdefine wideword_MSB 10000000000000000000000000000000b
 %ixdefine wideword_MSN 11110000000000000000000000000000b
 %ixdefine wideword_LSN 00000000000000000000000000001111b

 %ixdefine wideax    eax
 %ixdefine widecx    ecx
 %ixdefine widedx    edx
 %ixdefine widebx    ebx
 %ixdefine widesp    esp
 %ixdefine widebp    ebp
 %ixdefine widesi    esi
 %ixdefine widedi    edi

 %ixdefine _r8       dword[__r8]
 %ixdefine _r9       dword[__r9]
 %ixdefine _r10      dword[__r10]
 %ixdefine _r11      dword[__r11]
 %ixdefine _r12      dword[__r12]
 %ixdefine _r13      dword[__r13]
 %ixdefine _r14      dword[__r14]
 %ixdefine _r15      dword[__r15]

 __r8  dd 0
 __r9  dd 0
 __r10 dd 0
 __r11 dd 0
 __r12 dd 0
 __r13 dd 0
 __r14 dd 0
 __r15 dd 0


 %ixdefine awide     a32
 %ixdefine owide     o32


 %ixdefine pushfwide pushf
 %ixdefine popfwide  popf
 %ixdefine cmpswide  cmpsd
 %ixdefine lodswide  lodsd
 %ixdefine stoswide  stosd
 %ixdefine movswide  movsd
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_retwide1632"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iret
 %ixdefine End_iretwide  iret
 %macro End_iretwide 0
 iret
 db "End_iretwide1632"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push eax
 %ixdefine push_widesi push esi

 %ixdefine pop_wideax pop eax
 %ixdefine pop_widesi pop esi

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==32    ;32 bit x86 Protected Mode code

 %ixdefine _CALL_STACK_ADDR_SZ_ 4

 %ixdefine wideword    dword
 %ixdefine ww          dd
 %ixdefine wideword_SZ 4
 %ixdefine wideword_SZ_nibbles 8
 %ixdefine wideword_bits 32
 %ixdefine wideword_bits_BitRotationMultiply 5
 %ixdefine wideword_bits_mask 11111B
 %ixdefine wideword_SZ_BitRotationMultiply 2
 %ixdefine wideword_MSB 10000000000000000000000000000000b
 %ixdefine wideword_MSN 11110000000000000000000000000000b
 %ixdefine wideword_LSN 00000000000000000000000000001111b

 %ixdefine wideax    eax
 %ixdefine widecx    ecx
 %ixdefine widedx    edx
 %ixdefine widebx    ebx
 %ixdefine widesp    esp
 %ixdefine widebp    ebp
 %ixdefine widesi    esi
 %ixdefine widedi    edi

 %ixdefine _r8       dword[__r8]
 %ixdefine _r9       dword[__r9]
 %ixdefine _r10      dword[__r10]
 %ixdefine _r11      dword[__r11]
 %ixdefine _r12      dword[__r12]
 %ixdefine _r13      dword[__r13]
 %ixdefine _r14      dword[__r14]
 %ixdefine _r15      dword[__r15]

 __r8  dd 0
 __r9  dd 0
 __r10 dd 0
 __r11 dd 0
 __r12 dd 0
 __r13 dd 0
 __r14 dd 0
 __r15 dd 0


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushfd
 %ixdefine popfwide  popfd
 %ixdefine cmpswide  cmpsd
 %ixdefine lodswide  lodsd
 %ixdefine stoswide  stosd
 %ixdefine movswide  movsd
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret
 %macro End_retwide 0
 ret
 db "End_retwide32"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iretd
 %macro End_iretwide 0
 iretd
 db "End_iretwide32"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push eax
 %ixdefine push_widesi push esi

 %ixdefine pop_wideax pop eax
 %ixdefine pop_widesi pop esi

 %ixdefine push_es push es
 %ixdefine pop_es pop es

 %macro jmpfar 2
  jmp %1:%2
 %endmacro


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%elif _x86_Portable__PLATFORMBITS_==64       ;64-bit Long Mode code

 %ixdefine _CALL_STACK_ADDR_SZ_ 8

 %ixdefine wideword    qword
 %ixdefine ww          dq
 %ixdefine wideword_SZ 8
 %ixdefine wideword_SZ_nibbles 16
 %ixdefine wideword_bits 64
 %ixdefine wideword_bits_BitRotationMultiply 6
 %ixdefine wideword_bits_mask 111111B
 %ixdefine wideword_SZ_BitRotationMultiply 3
 %ixdefine wideword_MSB 1000000000000000000000000000000000000000000000000000000000000000b
 %ixdefine wideword_MSN 1111000000000000000000000000000000000000000000000000000000000000b
 %ixdefine wideword_LSN 0000000000000000000000000000000000000000000000000000000000001111b

 %ixdefine wideax    rax
 %ixdefine widecx    rcx
 %ixdefine widedx    rdx
 %ixdefine widebx    rbx
 %ixdefine widesp    rsp
 %ixdefine widebp    rbp
 %ixdefine widesi    rsi
 %ixdefine widedi    rdi

 %ixdefine _r8       r8
 %ixdefine _r9       r9
 %ixdefine _r10      r10
 %ixdefine _r11      r11
 %ixdefine _r12      r12
 %ixdefine _r13      r13
 %ixdefine _r14      r14
 %ixdefine _r15      r15


 %ixdefine awide
 %ixdefine owide


 %ixdefine pushfwide pushfq
 %ixdefine popfwide  popfq
 %ixdefine cmpswide  cmpsq
 %ixdefine lodswide  lodsq
 %ixdefine stoswide  stosq
 %ixdefine movswide  movsq
 %ixdefine inswide   insd
 %ixdefine outswide  outsd
 %ixdefine retwide   ret ;retq
 %macro End_retwide 0
 ret ;retq
 db "End_retwide64"
 align wideword_sz,db 'a'
 %endmacro
 %ixdefine iretwide  iretq
 %macro End_retwide 0
 iretq
 db "End_iretwide64"
 align wideword_sz,db 'a'
 %endmacro

 %ixdefine push_wideax push rax
 %ixdefine push_widesi push rsi

 %ixdefine pop_wideax pop rax
 %ixdefine pop_widesi pop rsi

 %ixdefine push_es 
 %ixdefine pop_es 

 %macro jmpfar 2

 %endmacro



%endif




;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set
;;;;INIT: Area for definitions with main platform width elements already set

 %macro pushawide 0
  ;PUSHA
  ;;
   push wideax
   push widecx
   push widedx
   push widebx
   push widesp
   add wideword[widesp],wideword_sz*5
   push widebp
   push widesi
   push widedi
 %endmacro

 %macro popawide 0
  ;POPA
  ;;
   pop widedi
   pop widesi
   pop widebp
   ;pop widesp
   add widesp,wideword_sz
   pop widebx
   pop widedx
   pop widecx
   pop wideax
 %endmacro



;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set
;;;;END:  Area for definitions with main platform width elements already set





%if _x86_Portable__LEVEL_==0  ;If privileged code, generate privileged instructions
 %ixdefine cliwide cli
 %ixdefine stiwide sti
 %ixdefine widecli cli
 %ixdefine widesti sti
%elif _x86_Portable__LEVEL_==1 ;If user code, don't generate those instructions
 %ixdefine cliwide
 %ixdefine stiwide
 %ixdefine widecli
 %ixdefine widesti
%endif


align 16
x86_Portable_END:





;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)
;;;;END:  x86 Portable (to make registers automatically sized and easy to assemble for 16/32/64 bits)












































































































;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging
;;;;INIT: Debugging

dbg_space_str db ' ',0



%macro printdbg_str_hexnum 4

%if isdbg==1
 pushfwide

 ;Simply jump whenever we define data
 ;in the middle of the program:
 ;;
  jmp .%1_jjmp

  .%1str db %2,%3
  .%1tmp times 64+8 db 0

  .%1_jjmp:

 ;Q: ???
 pushawide
 push widesi
  mov widesi,.%1str
  call console_kprint_visible
  mov widesi,_0x_str
  call console_kprint_visible
 pop widesi
  push wideax
  push widesi
  mov wideax,%4  ;what flags does it set with mov wideax,wideax?
  mov widesi,.%1tmp
   call console_kprint_uint32_16
   mov widesi,dbg_space_str
   call console_kprint_visible
  pop widesi
  pop wideax
 popawide
 ;A: ...

 popfwide
%endif


%endmacro











%macro include_debugstr 2

%if isdbg==1

jmp .%1
align wideword_sz
.%1str db %2,0
align wideword_sz
.%1:

%endif


%endmacro









;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging
;;;;END:  Debugging











































































































































































































































































;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions
;;;;INIT: VGA card functions



;Inputs:
;      BX == Byte cursor offset (0 to 65535).
;            Actually, these VGA registers don't take
;            into account the hidden attribute bytes, so
;            for them, a screen of 80x25 just has cursor
;            offsets that range from 0 to 65535.
;;
 VGAVideo_CRTC_setTextCurPos:
  push wideax
  push widebx
  push widedx
  pushf


   ;See if the specified cursor position
   ;is above the visible screen. If so,
   ;place the cursor in the very last
   ;visible position:
   ;;
    cmp bx,1999
    jbe .ok

     mov bx,1999


    .ok:


       mov al,14      ;reg 14 (MSB)
       mov ah,bh      ;MSB value
       mov dx,03D4h   ;index reg
       out dx,ax      ;specify r/w to CRTC port 14

       mov al,15      ;reg 15 (LSB)
       mov ah,bl      ;LSB value
       mov dx,03D4h   ;index reg
       out dx,ax      ;specify r/w to CRTC port 15


  popf
  pop widedx
  pop widebx
  pop wideax
 retwide






;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions
;;;;END:  VGA card functions














































































































































;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions
;;;;INIT: Kernel string functions

emptystr times 128 db ' '
                   db 0

 spcstr db ' ',0

_0x_str db "0x",0




;num2str_endchar equ '$'   ;For DOS
;num2str_endchar equ 0     ;For our own functions

num2str_endchar equ 0     ;For our own functions



;NOTE: This function should be exported by the kernel...
;      It should also preserve FLAGS, not let them be left altered
;;

;/*
; Inputs:
;        BL  -- base to convert to
;        EAX -- binary value to convert to string
;        EDI -- end of intended string (since the string
;               is generated backwards)
;
; Outputs:
;        ECX -- lenght of string
;        EDI -- start of the generated string
;
;*/
include_debugstr gioow4rg5jk4r5goik,"num2str"
num2str:
 push wideax
 push widebx
 push widedx
 push widebp
 pushfwide


 and ebx,11111111b;
 xor ecx,ecx;

 ;BUG: This function cannot call itself
 ;     with this debug macro, or it will loop
 ;     until crashing.
 ;;
 ;printdbg_str_hexnum sadflAFERFkfdt34,"num2str widedi: ",0,widedi



 mov byte[widedi],num2str_endchar
 dec edi




 cmp wideax,0
 jnz .noeax0;
   inc ecx;
   mov byte[widedi],'0';
   jmp .end;
 .noeax0:


 .while_ln_534543:
 cmp wideax,0
 jz .while_ln_534543_end

  inc widecx;
  

  ;//Clear EDX for the 32-bit-only division
  ;//and perform the assembly division:
  ;;
   xor widedx,widedx;
       div widebx;   ;//EDX:EAX / EBX == EAX quotient
                  ;//                 EDX remainder


  ;//Take a copy of the remainder:
  ;;
   mov widebp,widedx;


  ;//Convert binary remainder to ASCII value:
  ;;
   cmp dl,0
   jb .try10
   cmp dl,9
   ja .try10;
    add dl,0x30;  ;// '0' to '9'
   jmp .endif


   .try10:
   cmp dl,10
   jb .endif
    add dl,(0x41-10);  ;// 'A' and beyond


   .endif:


  ;//Put the character in the string:
  ;;
   mov byte[widedi],dl;





  dec widedi;


 jmp .while_ln_534543;
 .while_ln_534543_end:



  inc widedi;





 .end:
 popfwide
 pop widebp
 pop widedx
 pop widebx
 pop wideax
retwide





;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
;;;;END:  Kernel string functions
























































































































































;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions
;;;;INIT: Mode 03h text functions

console_ptr dd 0xB8000






;Inputs:
;       EDX == Value to test and for which, if
;              greater than the physical address
;              of the visible screen pointer,
;              will cause a software scroll effect
;              of the text screen, in 1 line.
;
;;
console_scroll_update:
   pushawide
   pushfwide


;    cmp dword[console_ptr],edx        ;0xB8000+4000
    cmp edx,0xB8000+4000
    jb .noScroll

      mov dword[console_ptr],0xB8000+4000-160
      mov esi,0xB8000+160
      mov edi,0xB8000
      mov ecx,(4000-160)/4
      rep movsd

      mov esi,0xB8000+4000-160
      mov eax,0x07200720
      mov ecx,160
      align wideword_sz
      rep stosd


    .noScroll:



   popfwide
   popawide
retwide





;Implementation:
;
;
;
;
;
;;
align wideword_sz
console_doCRLFeffect:
 pushf
 push wideax
 push widebx
 push widedx

  ;Take the current offset of the
  ;on-screen buffer to see if we
  ;are over the limit in which we
  ;should perform a (software) scrolling
  ;of the screen:
  ;;
   mov edx,[console_ptr]
   mov eax,edx    ;This is VITAL for the division
                  ;and we have removed it...
   add edx,160            ;We add this because if we
                          ;are at the last line and
                          ;do the CRLF effect for newline,
                          ;this sum will produce a value
                          ;that corresponds to an address
                          ;beyond the visible screen, and
                          ;that requires scrolling the
                          ;whole text screen.
    call console_scroll_update




  ;Remove the frame buffer base address from it
  ;to convert it into a simple offset:
  ;;
   sub eax,0xB8000

  ;Divide by 2, because our hardware cursor
  ;considers all screen positions as one-byte
  ;positions:
  ;;
   shr eax,1


  ;Prepare high DWORD for a 32-bit division:
  ;;
   xor edx,edx

  ;Divisor must be 80:
  ;;
   mov ebx,80


  ;Divide the screen offset by 80, to get the
  ;Y offset it represents:
  ;;
   div ebx    ;EDX:EAX/EBX  == EDX remainder, EAX quotient


  ;Prepare high DWORD for a 32-bit multiplication:
  ;;
   xor edx,edx


  ;Multiply our quotient by 80, to get a value that
  ;is aligned to 80. It represents X=0, and the
  ;correct value of Y:
  ;;
   mul ebx    ;EAX*EBX == EDX:EAX result

  
  ;Save the 32-bit multiplication in EAX:
  ;;
   mov ebx,eax

  ;See if we are in the last line. If so,
  ;avoid placing the cursor beyond that line:
  ;;
   cmp ebx,2000-80
   jae .nomoveCur

    ;But if we are in lines 0-78, advance one
    ;more line:
    ;;
     add ebx,80

  .nomoveCur:


  ;Re-position the hardware cursor based on
  ;all of the previous multiplications and divisions:
  ;;
   call VGAVideo_CRTC_setTextCurPos


  ;Now multiply this cursor position value by 2,
  ;to convert it to an actual 2-byte on-screen offset:
  ;;
   shl ebx,1

  ;Add the frame buffer base address so it turns into
  ;a valid memory offset:
  ;;
   add ebx,0xB8000

  ;Update the console pointer, pointing to the start of
  ;a new line:
  ;;
   mov [console_ptr],ebx



 pop widedx
 pop widebx
 pop wideax
 popf
retwide





;Implementation:
;
;This function can receive a screen offset of 3999,
;4000 or greater, but the first step in those cases
;is to move to a new line.
;
;
;
;Save all used registers and WIDEFLAGS.
;
;Take the screen base address for mode 03h.
;If it's greater than 0xB8000+4000, end to avoid
;printing beyond the visible screen.
;
;Set the attribute byte to normal color 7 in a
;temporary 8-bit register.
;
;Now enter loop .l
;Read a byte from our source string.
;If it's equal to the terminating char,
;in this case 0, go to the end of loop .l
;If not see if the index of our source string
;is lesser than 0xB8000+4000. If so, go to
;the end of loop .l
;If not, write a WORD to text screen.
;
;Update the current screen position variable for the
;cursor and for writing more text.
;
;
;Now move the hardware text cursor to the
;current string position. For this, take the
;current value of the mode 03h screen position,
;subtract it 0xB8000, divide it by 2 by shifting right
;1 bit, and that's the position in which the cursor
;should be currently in.
;
;Restore WIDEFLAGS and all used registers by the function.
;
;
;
;
;This function prints text only in the visible
;text screen range.
;
;Inputs:
;      WIDESI == ASCIIZ string to print
;
;;
 align wideword_sz
 _printf:
 console_kprint_visible:
  push wideax
  push widesi
  push widedi
  pushfwide

  cld
  ;widecli
  mov widedi,[console_ptr]

;cmp widedi,0xB8000+3999
;jae .no39990
;cli
;hlt
;
;.no39990:



  ;Avoid writing beyond the visible screen.
  ;With this, the screen/console pointer
  ;is never 3999 or greater in a parked way, so we have
  ;to go to a new line.
  ;;
;cmp widedi,0xB8000+4000-2   ;Reference == 3998
;jbe .notoffscreen0    ;<3999  (3998)
   cmp widedi,0xB8000+3999
   ;jb .notoffscreen
   jae .fixoffscreen0
   jmp .notoffscreen0
         ;push widecx
         ;mov widecx,0x5FFFFFF
         ;loop $
         ;pop widecx

     align wideword_sz
     .fixoffscreen0:
         ;push widecx
         ;mov widecx,0x5FFFFFF
         ;loop $
         ;pop widecx
     call console_doCRLFeffect

     ;Update the screen position after moving
     ;to a new line:
     ;;
      mov widedi,[console_ptr]

   align wideword_sz
   .notoffscreen0:
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ;cmp widedi,0xB8000+4000-2   ;Reference == 3998
   ;jbe .notoffscreen0    ;<3999  (3998)
   ;cmp widedi,0xB8000+4000-1   ;Reference == 3998
   ;jae .fixoffscreen0   ;>=3999 (4000)
   ;jmp .notoffscreen0   ;>=3998 || <=3999

   ;  align wideword_sz
   ;  .fixoffscreen0:
   ;  call console_doCRLFeffect

     ;Update the screen position after moving
     ;to a new line:
     ;;
   ;   mov widedi,[console_ptr]

   ;align wideword_sz
   ;.notoffscreen0:








  ;Place the attribute byte:
  ;;
   mov ah,7

    ;widesti
    align wideword_sz
    .l:
     lodsb
     cmp al,0
     je .l_END

     ;If we have reached a screen
     ;position beyond of the visible
     ;screen, break this loop to avoid
     ;overwriting unintended memory:
     ;;
      cmp widedi,0xB8000+3998
      ;jb .notoffscreen
      jae .fixoffscreen
      jmp .notoffscreen   ;(>=3998 && <=3999) ... (3998 || 3999) || <3998 ... 3999 || <3998 ... <3999

       ;widecli
        ;Dream: What if it never executes and we
        ;       cannot even execute this CLI HLT?
        ;       The reality is that we need to execute a
        ;       STOSW here before going to a new line because
        ;       we test a line jump for 3998, which is the valid
        ;       screen position of the very last char in the visible screen:
        ;;
         ;cli
         ;hlt
         ;push widecx
         ;mov widecx,0x5FFFFFF
         ;loop $
         ;pop widecx

        align wideword_sz
        .fixoffscreen:
         ;push widecx
         ;mov widecx,0x5FFFFFF
         ;loop $
         ;pop widecx
        stosw
        call console_doCRLFeffect

        ;Update the screen position after moving
        ;to a new line:
        ;;
         mov widedi,[console_ptr]
       ;widesti

      jmp .l
      align wideword_sz
      .notoffscreen:
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      ;cmp widedi,0xB8000+4000-2   ;Reference == 3998
      ;jbe .notoffscreen    ;<3999  (3998)
      ;cmp widedi,0xB8000+4000-1   ;Reference == 3998
      ;jae .fixoffscreen   ;>=3999 (4000)
      ;jmp .notoffscreen   ;>=3998 || <=3999

      ;  align wideword_sz
      ;  .fixoffscreen:
      ;  call console_doCRLFeffect

        ;Update the screen position after moving
        ;to a new line:
        ;;
      ;   mov widedi,[console_ptr]

      ;align wideword_sz
      ;.notoffscreen:




     stosw
;cmp widedi,0xB8000+4000
;jne .no39991
;cli
;hlt
;
;.no39991:


    jmp .l
    .l_END:


  ;Update the screen pointer:
  ;;
   mov [console_ptr],widedi



  ;Update the text screen hardware cursor:
  ;;
  ;widecli
   push widebx
    mov widebx,widedi
    sub widebx,0xB8000
    shr widebx,1
    call VGAVideo_CRTC_setTextCurPos
   pop widebx



  .END:

  popfwide
  pop widedi
  pop widesi
  pop wideax
 retwide




















;Inputs:
;       WIDEAX -- Value to convert
;       WIDESI -- Temporary buffer for resulting string
;
;;
console_kprint_uint32_16:
 pushfwide
 push wideax
 push widebx
 push widecx
 push widedx
 push widesi
 push widedi




 ; Inputs:
 ;        BL  -- base to convert to
 ;        EAX -- binary value to convert to string
 ;        EDI -- end of intended string (since the string
 ;               is generated backwards)
 ;
 ; Outputs:
 ;        ECX -- lenght of string
 ;        EDI -- start of the generated string
 ;
  mov bl,16
  mov widedi,widesi
  add widedi,12
  ;add widedi,64
  call num2str


 ;      ESI == ASCIIZ string to print
 ;
 ;;
  mov widesi,widedi
  call console_kprint_visible





 pop widedi
 pop widesi
 pop widedx
 pop widecx
 pop widebx
 pop wideax
 popfwide
retwide





;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions
;;;;END:  Mode 03h text functions































































































;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements
;;;;INIT: Raw memory elements

 align wideword_sz

 MEM_END   ww 0
 MEM_PAGES ww 0

 MEM_free_PAGES     ww 0
 MEM_reserved_PAGES ww 0

 KERNEL_PAGES  ww  KERN_SZ>>12

 APP_ADDRESS_START          ww  0  ;After the kernel and its runtime structures are complete,
                                   ;this is the point where everything else that is loaded
                                   ;is considered secondary application code, either kernel
                                   ;non-core code or programs.


;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements
;;;;END:  Raw memory elements

;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation
;;;;INIT: Raw memory manipulation

;Outuputs:
;         WIDEAX -- Last 4KB page base address. If 0, it means
;                   that all 4GB are valid.
;
;
;NOTE: Call this function when we already have timer interrupts
;      set up, or we won't be able to wait (it will probably lock up).
;
;
;Apart from the default hard-coded values, this function
;gives the default manual memory detection, and the values it
;configures could be reconfigured by other services like BIOS E820h.
;
;;
align wideword_sz
OPCODE__detect_32bit_memory_by_pages:
 pushfwide
 push widedi
 push widebx


 xor wideax,wideax


 ;Point to the end of the 4096-byte
 ;aligned kernel:
 ;;
  mov widedi,[_KERN_END]
  ;mov widesi,[_KERN_END]
  ;mov widesi,widedi

 ;Align kernel end to a 4-page cluster.
 ;This is key to properly account all
 ;subsequent clusters even after cluster-misaligned
 ;allocations at runtime for initialization:
 ;;
  add widedi,(4096*4)      ;Add the cluster size
  shr widedi,14            ;Divide by 16384
  shl widedi,14            ;Multiply by 16384 to align



; mov widedi,1048576*4

 align wideword_sz
 .memloop:


 ;See if we can write and keep the contents
 ;of the last DWORD of the page for
 ;a few milliseconds:
 ;;
 ;mov dword[widedi+4096-4],"PAMS"   ;Write a distinctive DWORD
  mov dword[widedi+(4096*4)-4],"PAMS"   ;Write a distinctive DWORD


 ;Wait 2 milliseconds:
 ;;
 ;mov al,2
 ;call PIT_8253_4__kwait


 ;See if it's still there:
 ;;
  cmp dword[widedi+(4096*4)-4],"PAMS"   ;Read a distinctive DWORD
  jne .endloop


 ;Go to the next 4-page cluster. If it becomes 0,
 ;we already tested all 4GB:
 ;;
  add widedi,(4096*4)
  ;jz .endloop       ;Does ADD set the Zero Flag? If so, just use this line
  test widedi,widedi
  jz .endloop


 jmp .memloop



 align wideword_sz
 .endloop:


 mov wideax,widedi    ;Return the amount of 32-bit RAM (base address of last page)
;sub wideax,4096



 ;Update kernel variables:
 ;;
 
 ;Last addressable byte:
 ;;
 ;Memory size in number of bytes-1:
 ;;
  mov [MEM_END],wideax
  dec wideword[MEM_END]
  ;add wideword[MEM_END],4095   ;Point to the last addressable byte
  ;dec wideword[MEM_END]       ;MEM_SZ-1







 ;Memory size in number of pages:
 ;;
  mov [MEM_PAGES],wideax      ;RAM size
 ;mov [MEM_PAGES],wideax      ;RAM size-1
 ;inc wideword[MEM_PAGES]     ;RAM size
  shr wideword[MEM_PAGES],12  ;Divide by 4096 to get number of pages
  cmp wideword[MEM_PAGES],0   ;If 0, the full 4GB are installed
  jne .mempagesok

   mov wideword[MEM_PAGES],1048576

  align wideword_sz
  .mempagesok:











 ;Size of physical memory bitmap in pages :
 ;;
  push wideword[MEM_PAGES]                     ;Number of installed pages
  push wideword[MEM_PAGES]                     ;Number of installed pages
  pop wideword[KERNEL_PAGE_BITMAP_pgsz]
  pop  wideword[MEM_free_PAGES]            ;If we don't do it here we will lose any and all precision.

  shr wideword[KERNEL_PAGE_BITMAP_pgsz],3   ;Divide by the bits in a byte to get the bitmap size in bytes

  push wideword[KERNEL_PAGE_BITMAP_pgsz]   ;Size of bitmap in bytes.
  pop  wideword[KERNEL_PAGE_BITMAP_end]    ;If we don't do it here we will lose any and all precision.



  shr wideword[KERNEL_PAGE_BITMAP_pgsz],12  ;Divide by the bits in a byte to get the bitmap size in bytes




  cmp wideword[KERNEL_PAGE_BITMAP_pgsz],0
  jne .pagesznot0

    inc wideword[KERNEL_PAGE_BITMAP_pgsz]


  align wideword_sz
  .pagesznot0:



  printdbg_str_hexnum vwaefgstr,"Bitmap size in pages: ",0,wideword[KERNEL_PAGE_BITMAP_pgsz]








;131072 bytes for 4GB bitmap pages
;maximum 1048576 4kb pages
;1 bit per 4kb page == 131072 bytes for physical free/used memory bitmap


;Function for counting pginas fsicas libres/usadas
;Funciones para contar los recursos libres/usados de cada subsistema


;Formato: Hacer una bomba de esfuerzo, detener y reanudar los juegos, y tambin trabajar de esa misma forma para ver si nos va mejor que en la vez pasada, en este caso es para




 sub wideax,4096





  printdbg_str_hexnum vwefgstr,"Memory size: ",0,wideax


 pop widebx
 pop widedi
 popfwide
retwide










;Implementation
;--------------
;
;Save WIDEFLAGS and used registers at the start and
;restore at the end.
;
;Pass the page count in WIDEAX.
;
;Save the original page count in WIDEBX.
;
;Add the requested page number to KERNEL_PAGES
;and put it back in WIDEAX.
;
;Now multiply WIDEAX and WIDEBX by 4096 by
;shifting them 12 bits left.
;
;WIDEAX contains the current total number
;of kernel bytes.
;
;WIDEBX contains the bytes requested in this call.
;
;
;Now we have the total number of bytes in WIDEAX,
;so add KERNEL_BASE to get the actual pointer
;1 byte right after the kernel.
;
;Put WIDEAX back in _KERN_END.
;
;Now subtract WIDEAX-WIDEBX to get a pointer
;to the actual start of the page block we just requested.
;
;-----------------------
;Implementation Complete
;
;Inputs:
;      WIDEAX -- Page count
;
;
;Outputs:
;        WIDEAX -- Address of the block at the end of the kernel
;;
function_malloc_Append_Kernel_Pages db "malloc_Append_Kernel_Pages",0
align wideword_sz
kalloc_Append_Kernel_Pages:
malloc_Append_Kernel_Pages:
 pushfwide
 push widebx


 ;Get a copy of the page count:
 ;;
  mov widebx,wideax


 ;Save the number of kernel pages
 ;and get the new count:
 ;;
  printdbg_str_hexnum yh54hsdafgasdj54y,"Initial multiple pages: ",0,[KERNEL_PAGES]
  add [KERNEL_PAGES],wideax
  mov wideax,[KERNEL_PAGES]



 ;Multiply te count by 4096 to get
 ;the new kernel size:
 ;;
  shl wideax,12   ;Full kernel page byte count
  shl widebx,12   ;Requested page byte count on this call




 ;Add the size of the pages
 ;to the end of kernel address:
 ;;
;  mov [_KERN_END],wideax      ;Update to the size of our page block
;  mov wideax,[_KERN_END]      ;Get the new kernel size in WIDEAX

  add wideax,KERNEL_BASE
  mov wideword[_KERN_END],wideax  ;Adjust to the kernel load base address


  sub wideax,widebx  ;Subtract it bytes to the pointer to get the base address of this page block,
                     ;not the very end of the kernel block, which is a huge error.


  printdbg_str_hexnum yh54fasdf4y,"End multiple pages: ",0,[KERNEL_PAGES]


 pop widebx
 popfwide
retwide



;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation
;;;;END:  Raw memory manipulation







































































































;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data
;;;;INIT: Raw binary data



;Implementation
;--------------
;
;
;
;
;
;
;-----------------------
;Implementation Complete
;
;
;Inputs:
;       WIDESI -- WIDEWORD array base address
;       WIDECX -- Number of elements
;
;
;Outputs:
;       WIDEAX -- Address of first free WIDEWORD
;
;;
align wideword_sz
OPCODE__binary_data__find_first_free_WIDEWORD:
 pushfwide
 push widesi
 push widecx



   align wideword_sz
   .loop_start:
   cmp wideword[widesi],0
   jz .loop_end

     dec widecx
     add widesi,wideword_sz


   jmp .loop_start
   align wideword_sz
   .loop_end:



 mov wideax,widesi

 pop widecx
 pop widesi
 popfwide
retwide



;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data
;;;;END:  Raw binary data





























































































;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data
;;;;INIT: Physical kernel page bitmap data

 KERNEL_PAGE_BITMAP      ww 0
 KERNEL_PAGE_BITMAP_pgsz ww 0
 KERNEL_PAGE_BITMAP_sz   ww 0
 KERNEL_PAGE_BITMAP_end  ww 0


;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data
;;;;END:  Physical kernel page bitmap data

;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions
;;;;INIT: Bitmap manipulation functions




;This function must be called when absolutely
;anything else is left to do (components added
;dynamically at the end of the physical kernel,
;malloc pointers, basic paging for the kernel,
;TSS or other multitasking means), as it will
;simply mark the contiguous memory block from
;the start of memory for a whole Megabyte, to
;the last page of the kernel, to avoid reusing it
;for further allocations once the base kernel is going.
;
;;
align wideword_sz
OPCODE__memory__initialize_system_bitmapped_memory:
 pushfwide
 pushawide


 ;Allocate memory for the physical memory
 ;bitmap at the end of the kernel. This should be
 ;the last page to allocate with this function:
 ;;
printdbg_str_hexnum grewgwr54,"init KERN_SZ: ",0,KERN_SZ
printdbg_str_hexnum gsewgwr54,"init KERNEL_PAGE_BITMAP_pgsz: ",0,wideword[KERNEL_PAGE_BITMAP_pgsz]
;printdbg_str_hexnum gsewgwr54,"init KERNEL_PAGE_BITMAP_PAGE_SZ: ",0,KERNEL_PAGE_BITMAP_PAGE_SZ
  mov wideax,[KERNEL_PAGE_BITMAP_pgsz]
 ;mov wideax,KERNEL_PAGE_BITMAP_PAGE_SZ
  call kalloc_Append_Kernel_Pages
  mov wideword[KERNEL_PAGE_BITMAP],wideax

;  push wideax
;  mov wideword[KERNEL_PAGE_BITMAP_end],wideax
;
;
;  ;mov wideax,[KERNEL_PAGE_BITMAP_pgsz]
;  ;shl wideax,12
;  ;add [KERNEL_PAGE_BITMAP_end],wideax
;
;
;  ;add wideword[KERNEL_PAGE_BITMAP_end],KERNEL_PAGE_BITMAP_SZ
;
;
;  mov wideax,[KERNEL_PAGE_BITMAP_sz]
;  add wideword[KERNEL_PAGE_BITMAP_end],wideax
;  pop wideax






 ;Set those pages to 0 (all free):
 ;;
 ;mov widecx,KERNEL_PAGE_BITMAP_SZ/wideword_sz
  ;mov widecx,[KERNEL_PAGE_BITMAP_sz]
  mov widecx,[KERNEL_PAGE_BITMAP_end]
  shr widecx,wideword_bits_BitRotationMultiply
  ;

printdbg_str_hexnum gsewgwrd54,"init KERNEL_PAGE_BITMAP_sz: ",0,wideword[KERNEL_PAGE_BITMAP_end]
;cli
;hlt


  mov widedi,wideax
  xor wideax,wideax
  align wideword_sz
  rep stoswide




 ;Mark the first Megabyte as used:
 ;;
  mov widecx,32/wideword_sz       ;256 entries cover 1MB

 ;Update reserved/free pages:
 ;;
  sub wideword[MEM_free_PAGES],256
  add wideword[MEM_reserved_PAGES],256

printdbg_str_hexnum grg43egwr54,"init number of widewords to set for first MB: ",0,widecx
  mov wideax,-1
  mov widedi,[KERNEL_PAGE_BITMAP]
  align wideword_sz
  rep stoswide



 ;Mark the kernel pages as used:
 ;;
  mov widecx,[KERNEL_PAGES]

 ;Update reserved/free pages:
 ;;
  sub wideword[MEM_free_PAGES],widecx
  add wideword[MEM_reserved_PAGES],widecx

  ;mov widecx,KERN_SZ/4096/wideword_bits   ;Convert number of kernel bytes into number of page bits
  shr widecx,wideword_bits_BitRotationMultiply



printdbg_str_hexnum rg54t43rgwr54,"init number of full kernel bitmap widewords: ",0,widecx
  mov wideax,-1
  ;mov widedi,[KERNEL_PAGE_BITMAP]
  ;add widedi,32
  align wideword_sz
  rep stoswide


 ;Mark the kernel pages as used that cover a partial wideword.
 ;If we don't do it in this way, we could reserve too much or
 ;too little memory, in short not as many pages as there really are:
 ;;
printdbg_str_hexnum fy5464543rgwr54,"init num kernel pages: ",0,[KERNEL_PAGES]
  mov widecx,[KERNEL_PAGES]
  ;mov widecx,((KERN_SZ/4096) % wideword_bits)
  and widecx,wideword_bits_mask


 ;Update reserved/free pages:
 ;;
  sub wideword[MEM_free_PAGES],widecx
  add wideword[MEM_reserved_PAGES],widecx


printdbg_str_hexnum fewrrg54t43rgwr54,"init number of partial wideword bitmap bits: ",0,widecx
  mov wideax,wideword_MSB
printdbg_str_hexnum rg54t43rhg54rgwr54,"init wideword_MSB: ",0,wideword_MSB
  align wideword_sz
  .partloop:
    or wideword[widedi],wideax
    shr wideax,1
  dec widecx
  jnz .partloop




 popawide
 popfwide
retwide



;Implementation
;--------------
;
;
;
;
;
;
;Inputs:
;      WIDECX -- Bitmap size in bytes
;      WIDESI -- Start search offset
;
;
;Outputs:
;       WIDESI -- Byte offset |bitmap_start+bitmap size, bitmap end address on error|
;       CL     -- Bit left-shift count of first free bit |zero to wideword_sz-one|
;
;
;;
align wideword_sz
OPCODE__data_bitmap__get_free_bits_offsets:
 pushfwide
 push wideax
 push widebx
; push widesi

printdbg_str_hexnum rg54t43rhg54rwr54,"WIDESI base bitmap: ",0,widesi
   align wideword_sz
   .sl0:

    ;Read a wideword and see if all bits
    ;are set to 1. If not, continue:
    ;;
     lodswide
     cmp wideax,-1   ;If there are free bits, we have free bitmap elemennts
     je .sl0_end_test

      ;If we found a wideword with 0 bits,
      ;rewind the bitmap pointer to a wideword
      ;to point again exactly to the partially free
      ;wideword:
      ;;
       sub widesi,wideword_sz
       jmp .sl0_end

     align wideword_sz
     .sl0_end_test:


   ;dec widecx
   sub widecx,wideword_sz
   jnz .sl0
   jz .end
   align wideword_sz
   .sl0_end:
printdbg_str_hexnum rg54t43hg54rgwr54,"WIDESI found wideword offset: ",0,widesi

  ;If we didn't exhaust all bimap entries,
  ;we found a match with free pages:
  ;;
   ;cmp widecx,0
   ;jne .bitmapok

   ;   jmp .end

   ;align wideword_sz
   ;.bitmapok:



  ;Load WIDEBX with the bit count for the
  ;machine word size. Rotate all bits and
  ;wait once we find a bit cleared to 0:
  ;;
   xor widecx,widecx
   mov widebx,wideword_bits
   mov cl,0
   align wideword_sz
   .sl1:

     test wideax,wideword_MSB
     jz .sl1_end


   shl wideax,1
   inc cl
   dec widebx
   jnz .sl1
   align wideword_sz
   .sl1_end:
printdbg_str_hexnum rg54t43hgr4rgwr54,"WIDECX found bit offset: ",0,widecx



 ;mov wideax,widesi





 align wideword_sz
 .end:


; pop widesi
 pop widebx
 pop wideax
 popfwide
retwide














;SUPER IMPORTANT FOR PAGING/MEMORY MANAGEMENT
;
;
;
;
;Mark the page address as free.
;
;Other version of this function could specify
;the current address of the bitmap in WIDESI,
;maybe useful for multitasking but I don't know.
;
;
;Inputs:
;      WIDEAX -- Used 4K page address. If it's already free,
;                it has no effect.
;;
align wideword_sz
OPCODE__data_bitmap__free_physical_memory_address:
 pushfwide
 push wideax
 push widebx
 push widecx
 push widesi

 ;Divide address by the page size and also
 ;by the number of bits in a wideword.
 ;Then multiply by the size of the wideword in bytes
 ;It will result in the wideword offset
 ;that we must manipulate:
 ;;
  mov widebx,wideax
  shr widebx,12+wideword_bits_BitRotationMultiply
  shl widebx,wideword_SZ_BitRotationMultiply
printdbg_str_hexnum rg54t4vhgr4zgwr54,"free bitmap offset: ",0,widebx




 ;Divide address again by the page size.
 ;Then save the lower bits to get the number of bits
 ;of a potentially partial wideword:
 ;;
  mov widecx,wideax
  shr widecx,12
  and widecx,wideword_bits_mask
printdbg_str_hexnum rgsa4t4vhgr4zgwr54,"free bit offset: ",0,widecx

 ;Add the base of the bitmap:
 ;;
  add widebx,[KERNEL_PAGE_BITMAP]

 ;Get an all-one bitmask and rotate it
 ;as many positions left to right
 ;as CL says:
 ;;
  mov wideax,01111111111111111111111111111111b
  ror wideax,cl



 ;Disable the specified bit:
 ;;
  and [widebx],wideax


 pop widesi
 pop widecx
 pop widebx
 pop wideax
 popfwide
retwide



























;SUPER IMPORTANT FOR PAGING/MEMORY MANAGEMENT
;
;
;
;
;
;
;
;
;
;Inputs:
;      WIDESI -- Bitmap offset |zero-based address|
;      CL     -- Bitmap offset
;
;Outputs:
;       WIDEAX -- 4096-byte addresss
;
;
;;
align wideword_sz
OPCODE__data_bitmap_offset_to_4K_address:
 pushfwide
 push widecx
 push widesi


;printdbg_str_hexnum g54tgko.54tg34.,"WIDESI to convert: ",0,widesi
;printdbg_str_hexnum s5e4yw54tl.wetfweq.s,"CL to convert: ",0,widecx
;sti
;call exittodos  ;Lockup point to debug
                 ;(these debug strings break the program, improve the debug macro)




 shr widesi,wideword_SZ_BitRotationMultiply   ;widesi/wideword_sz to get number of widewords
 shl widesi,wideword_bits_BitRotationMultiply ;widesi*wideword_numbits to get number of pages
 shl widesi,12                                ;widesi*4096 to convert to byte offset

 shl widecx,12;wideword_SZ_BitRotationMultiply  ;Convert bit count to 4KB page count in bytes
 add widesi,widecx
 mov wideax,widesi

printdbg_str_hexnum rg54t43hgr4zgwr54,"OPCODE__data_bitmap_offset_to_4K_address: ",0,wideax





 pop widesi
 pop widecx
 popfwide
retwide











;SUPER IMPORTANT FOR PAGING/MEMORY MANAGEMENT
;
;
;
;
;Mark the page address as used.
;
;
;
;Outputs:
;       WIDEAX -- Newly-reserved 4K page address ([KERNEL_PAGE_BITMAP] on error
;                 as the bitmap memory region can never be reassigned).
;;
align wideword_sz
OPCODE__data_bitmap__get_free_physical_memory_address:
 pushfwide
 push widebx
 push widecx
 push widedx
 push widesi

 ;Inputs:
 ;      WIDECX -- Bitmap size in bytes
 ;      WIDESI -- Start search offset
 ;
 ;
 ;Outputs:
 ;       WIDESI -- Bitmap address |bitmap_start+bitmap size, bitmap end address on error|
 ;       CL     -- Bit left-shift count of first free bit |zero to wideword_sz-one|
 ;       
 ;       
 ;;
 ;mov widecx,KERNEL_PAGE_BITMAP_SZ
;  mov widecx,[KERNEL_PAGE_BITMAP_sz]
  mov widecx,[KERNEL_PAGE_BITMAP_end]
  mov widesi,[KERNEL_PAGE_BITMAP]
  call OPCODE__data_bitmap__get_free_bits_offsets
  mov widedx,widesi
  sub widedx,[KERNEL_PAGE_BITMAP]
  cmp widedx,[KERNEL_PAGE_BITMAP_end]
  jne .ok

    mov wideax,[KERNEL_PAGE_BITMAP]
    jmp .end


  align wideword_sz
  .ok:


 ;Set the bit as reserved:
 ;;
  mov widebx,wideword_MSB
  shr widebx,cl
  or wideword[widesi],widebx



 ;Inputs:
 ;      WIDESI -- Bitmap offset |zero-based address|
 ;      CL     -- Bitmap offset
 ;
 ;Outputs:
 ;       WIDEAX -- 4096-byte addresss
 ;
 ;
 ;;
  sub widesi,[KERNEL_PAGE_BITMAP]
  call OPCODE__data_bitmap_offset_to_4K_address




 align wideword_sz
 .end:


 pop widesi
 pop widedx
 pop widecx
 pop widebx
 popfwide
retwide






;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions
;;;;END:  Bitmap manipulation functions































































































;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions
;;;;INIT: 32-bit paging functions

;A certain number of CR3 registers mapped
;physically in the main kernel image should
;allow us to switch/swap address spaces enough.
;
;This needs to be aligned to 4096 since it's
;the most important thing to map globally in
;any paging directory, but the main kernel
;image should also be mapped, so it should be
;minimal/small, for what concerns the kernel:
;;
db 'CR3_array'
align 4096
CR3_array times 128 ww 0

CR3_index ww 0


                                                        ;       -
_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_TRUE    equ 00000001b
_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_FALSE   equ 00000000b
                                                        ;       -
                                                        ;      -
_FLAG_x86_32_pageDirectoryEntry_Bit1_ReadWrite       equ 00000010b
_FLAG_x86_32_pageDirectoryEntry_Bit1_ReadOnly        equ 00000000b
                                                        ;      -
                                                        ;     -
_FLAG_x86_32_pageDirectoryEntry_Bit2_SupervisorLevel equ 00000000b
_FLAG_x86_32_pageDirectoryEntry_Bit2_UserLevel       equ 00000100b
                                                        ;     -
                                                        ;    -
_FLAG_x86_32_pageDirectoryEntry_Bit3_WriteBack       equ 00000000b
_FLAG_x86_32_pageDirectoryEntry_Bit3_WriteThrough    equ 00001000b
                                                        ;    -
                                                        ;   -
_FLAG_x86_32_pageDirectoryEntry_Bit4_DisableCache    equ 00010000b
_FLAG_x86_32_pageDirectoryEntry_Bit4_EnableCache     equ 00000000b
                                                        ;   -





                                          ;       -
CPU_x86_32_Paging_Bit0_Present_TRUE    equ 00000001b
CPU_x86_32_Paging_Bit0_Present_FALSE   equ 00000000b
                                          ;       -
                                          ;      -
CPU_x86_32_Paging_Bit1_ReadWrite       equ 00000010b
CPU_x86_32_Paging_Bit1_ReadOnly        equ 00000000b
                                          ;      -
                                          ;     -
CPU_x86_32_Paging_Bit2_SupervisorLevel equ 00000000b
CPU_x86_32_Paging_Bit2_UserLevel       equ 00000100b
                                          ;     -
                                          ;    -
CPU_x86_32_Paging_Bit3_WriteBack       equ 00000000b
CPU_x86_32_Paging_Bit3_WriteThrough    equ 00001000b
                                          ;    -
                                          ;   -
CPU_x86_32_Paging_Bit4_DisableCache    equ 00010000b
CPU_x86_32_Paging_Bit4_EnableCache     equ 00000000b
                                          ;   -
                                          ;  -
CPU_x86_32_Paging_Bit5_Accessed_FALSE  equ 00000000b
CPU_x86_32_Paging_Bit5_Accessed_TRUE   equ 00100000b
                                          ;  -
                                          ; -
CPU_x86_32_PageTable_Bit6_Dirty_FALSE  equ 00000000b
CPU_x86_32_PageTable_Bit6_Dirty_TRUE   equ 01000000b
                                          ; -
                                                      ;-
CPU_x86_32_PageTable_Bit7_PageAttributeTable_FALSE equ 00000000b
CPU_x86_32_PageTable_Bit7_PageAttributeTable_TRUE  equ 10000000b
                                                      ;-
                                              ;-
CPU_x86_32_PageTable_Bit8_GlobalPage_FALSE equ 0_00000000b
CPU_x86_32_PageTable_Bit8_GlobalPage_TRUE  equ 1_00000000b
                                              ;-
                                                     ;   -
CPU_x86_32_PageDir_Bit12_PageAttributeTable_FALSE equ 00000000_00000000b
CPU_x86_32_PageDir_Bit12_PageAttributeTable_TRUE  equ 00010000_00000000b
                                                     ;   -







                                       ;    ---
CPU_x86_32_Paging_Bit9_11_AVL_0     equ 00000000_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_1     equ 00000010_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_2     equ 00000100_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_3     equ 00000110_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_4     equ 00001000_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_5     equ 00001010_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_6     equ 00001100_00000000b
CPU_x86_32_Paging_Bit9_11_AVL_7     equ 00001110_00000000b
                                       ;    ---









;Prerequisites
;-------------
;
;- Capability to reserve physical contiguous pages to the end of the kernel.
;- Reserve an array for CR3 values (to switch contexts).
;
;
;
;Implementation
;--------------
;
;Save all general purpose registers and WIDEFLAGS
;at the start an restore at the end.
;
;Load CR3 with WIDEDI, and also save it at the first
;free WIDEWORD of the CR3 array. When initializing the
;kernel with paging, the very first element of the CR3
;array should be free, so it will also always be the
;CR3 value for the base kernel.
;
;Create 1024 entries with Not Present pages, Read/Write
;Supervisor Level, and address 0. It will then be easy to modify
;entries when allocating/freeing/setting privileges/etc.
;
;Here, what is important, is not address 0, but the Not Present
;flag. The physical address is important as it indicates strictly
;which page will become free, so we will probably need a pointer
;to an empty page in the kernel as a NULL pointer when allocating/freeing
;so we can automatically validate unequivocally which pages are truly free
;or allocated, to have a value known to the kernel against which to check
;such free (non-allocated) pages.
;
;-----------------------
;Implementation Complete
;
;
;
;Inputs:
;       WIDEDI -- 4KB-aligned memory address
;                 to place the generated page directory.
;
;;
OPCODE__CPU_generate_4KB_empty_page_directory:
 push wideax
 push widecx
 push widesi
 push widedi
 pushfwide

 ;Create 1024 entries with Not Present pages, Read/Write and Supervisor Level:
 ;;
  mov wideax,_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_FALSE|_FLAG_x86_32_pageDirectoryEntry_Bit1_ReadWrite|_FLAG_x86_32_pageDirectoryEntry_Bit2_SupervisorLevel
  mov widecx,1024
  align wideword_sz
  rep stosd




 popfwide
 pop widedi
 pop widesi
 pop widecx
 pop wideax
retwide






;Inputs:
;      WIDEDI -- Page directory to load into CR3
;
;      WIDESI -- CR3 values array base address
;      WIDECX -- Number of elements in the CR3 values array
;                (0 if storing it into the system CR3 array isn't desired,
;                for example to return from a single-tasking fast task
;                created by the kernel)
;
;Outputs:
;        WIDEAX -- Offset of the CR3 values array where
;                  the CR3 array was stored.
;
;
;;
align wideword_sz
OPCODE__CPU_load_CR3_paging:
 pushfwide


 ;Load the page directory into CR3
 ;and store the kernel page directory
 ;in element 0 of the system's CR3 values array:
 ;;
  mov cr3,widedi


 ;Disable saving the CR3 into an array
 ;if the size of the array is specified 0:
 ;;
  cmp widecx,0
  jz .dont_save_cr3_into_array


  ;Inputs:
  ;       WIDESI -- WIDEWORD array base address
  ;       WIDECX -- Number of elements
  ;
  ;
  ;Outputs:
  ;       WIDEAX -- Address of first free WIDEWORD
  ;
  ;;
  ;Store the kernel page directory
  ;in element 0 of the system's CR3 values array:
  ;;
   call OPCODE__binary_data__find_first_free_WIDEWORD
   mov [wideax],widedi

 align wideword_sz
 .dont_save_cr3_into_array:



 popfwide
retwide








;Implementation Complete
;
;
;
;
;
;
;
;
;
;
;
;
;;
;;;
;;;;
db "OPCODE__CPU_Enable_Default_Paging",0
align wideword_sz
OPCODE__CPU_Enable_Default_Paging:
 push wideax
 push widebx
 pushfwide


 ;Enable paging bit 31 in CR0.
 ;Bit 31 for paging makes thing as if
 ;paging was the best, most difficult
 ;thing from the x86 CPU, the last thing left
 ;that was done:
 ;;
 ;
 ;Load the bitmask in WIDEBX to avoid the
 ;or wideax,10000... instruction to sign extend
 ;the value, which would cause the wrong effect
 ;in 64-bit mode.
 ;
 ;;
  mov wideax,cr0
  mov widebx,10000000_00000000_00000000_00000000b
  or wideax,widebx
  mov cr0,wideax


 popfwide
 pop widebx
 pop wideax
retwide







;Implementation Complete
;
;
;
;
;
;
;
;
;
;
;
align wideword_sz
OPCODE__CPU_Disable_Default_Paging:
 push wideax
 pushfwide


 ;Disable paging bit 31 in CR0.
 ;
 ;;
  mov wideax,cr0
  and wideax,01111111_11111111_11111111_11111111b
  mov cr0,wideax


 popfwide
 pop wideax
retwide

















;Inputs:
;      WIDESI -- Virtual address to modify
;
;Outputs:
;       WIDEAX -- Byte offset into a page directory
;;
align wideword_sz
OPCODE__CPU_x86_32_addr2pagedirent:
 pushfwide

 ;Convert bits 22-31 to page directory entry index offset:
 ;;
  mov wideax,widesi   ;Put virtual address in WIDEAX
  shr wideax,22       ;Only get page directory index bits
  shl wideax,2        ;Multiply index by 4




 popfwide
retwide












;Inputs:
;      WIDEDX -- CR3 array offset address
;      WIDESI -- Page directory entry to modify
;      WIDEAX -- Physical address to point to and attribute bits
;;
align wideword_sz
OPCODE__CPU_x86_32_map_physical_pagedir_entry:
 pushfwide
 push widebx
 push widedx
 push widesi


 ;Get the base address of the specified
 ;page directory in WIDEDX:
 ;;
  mov widedx,[widedx*wideword_sz+CR3_array]


 ;Convert bits 22-31 to page directory entry index offset:
 ;;
  mov widebx,widesi   ;Put virtual address in WIDEBX
  shr widebx,22       ;Only get page directory index bits
  shl widebx,2        ;Multiply index by 4
  add widebx,widedx   ;Go to page directory base address


 ;Set the physical address and attributes in the entry
 ;in WIDEBX:
 ;;
  mov [widebx],wideax  ;Set page directory entry


 pop widesi
 pop widedx
 pop widebx
 popfwide
retwide











;Implementation
;
;
;
;
;
;
;
;
;
;
;
;Inputs:
;      WIDEDX -- CR3 array offset address
;      WIDESI -- Virtual address to modify
;      WIDEDI -- New physical address to point to
;;
align wideword_sz
OPCODE__CPU_x86_32_remap_physical_page_address:
 pushfwide
 push widebx
 push widecx
 push widedx
 push widesi
 push widebp
 cli
 call OPCODE__CPU_Disable_Default_Paging

 printdbg_str_hexnum srdag54wyh4rfdt34,"New page table address start: ",0,widedi

 ;Get the base address of the specified
 ;page directory in WIDEDX:
 ;;
  mov widedx,[widedx*wideword_sz+CR3_array]
 printdbg_str_hexnum srdsfsdasdvfdt34,"Current CR3: ",0,widedx
;cli
;hlt


 ;Convert bits 22-31 to page directory entry index offset:
 ;;
  mov widebx,widesi   ;Put virtual address in WIDEBX
  shr widebx,22       ;Only get page directory index bits
  shl widebx,2        ;Multiply index by 4
  add widebx,widedx   ;Go to page directory base address

 printdbg_str_hexnum srdfsasdfdt34,"Remap virtual address: ",0,widesi



 ;Read the physical address in the entry
 ;in WIDEBX:
 ;;
  mov widebx,[widebx]  ;Get page directory entry value... it might reset the CPU
  and widebx,11111111111111111111000000000000b        ;Get rid of attribute bits





 ;Convert bits 12-21 to page table base address:
 ;;
  mov widecx,widesi     ;Load virtual address in DX
  shl widecx,10         ;Get rid of bits 22-31
  shr widecx,10+12      ;Get only page table index bits
 printdbg_str_hexnum srsdfsadsdfdt34,"Page table index 0-1023: ",0,widecx
  shl widecx,2          ;Multiply by 4 to go to the actual entry
  add widecx,widebx     ;Go to the page table base address



 ;Read the physical address of the virtual page table
 ;and only preserve type/attribute bits and...:
 ;;
  mov widesi,[widecx]
  mov widebp,widesi
  shl widesi,20
  shr widesi,20

  shr widebp,12
  shl widebp,12
  ;mov [testaddr],widebp


 printdbg_str_hexnum srdgq34fdt34,"Remap page table address: 0x",0,widebp

 ;...place the new address instead:
 ;;
  or widesi,widedi
  mov wideax,widedi
 printdbg_str_hexnum srdgvvv4fdt34,"Remap widedi address: 0x",0,wideax
 mov wideax,widesi
 printdbg_str_hexnum srdgvvvq34fdt34,"Remap widesi address: 0x",0,wideax
 ;cli
 ;hlt
  mov [widecx],widesi


; printdbg_str_hexnum srdag54wyh4rfdt34,"New page table address: ",0,widesi
 printdbg_str_hexnum srdgvq34fdt34,"New Remap address: 0x",0,widedi


 call OPCODE__CPU_Enable_Default_Paging
 pop widebp
 pop widesi
 pop widedx
 pop widecx
 pop widebx
 popfwide
retwide






































































;Finding free addresses or checking if an address
;is already taken is done somewhere else. Not checking
;will be useful here to immediately swap addresses in
;a single operation, which is critical for system speed.
;
;It's better to reserve what we will need of RAM/disk
;memory, and not allocate again to speed up everything.
;
;
;
;
;

;Description: This function will fully overwrite whatever
;             is in the paging entries for the
;             specified physical address. If there is
;             something valid at that position, it must be
;             swapped out beforehand.
;
;             It will also force to 1 the bits in the
;             physical memory bitmap.
;
;             As it is, it requires paging enabled
;             as it uses physical/virtual address redirection.
;
;
;Inputs:
;      WIDESI -- Index in the CR3 array 0 to N.
;      WIDEAX -- Privilege/type flags and [UNUSED IN THIS FUNCTION]manual target physical address.
;      WIDEDI -- Target virtual address (0 for identity mapping)
;
;
;Outputs:
;       WIDEAX -- New virtual page address
;
;;
align wideword_sz
OPCODE__CPU_x86_32_raw_paging_allocate_physical_4KB_page:
 pushfwide
 cli
 push widebx
 push widecx
 push widedx
 push widebp

 push widesi
 push widedi
 push wideax

 ;call OPCODE__CPU_Read_Default_Paging
 ;push wideax
 
 call OPCODE__CPU_Disable_Default_Paging



 ;Get the specified CR3 index from the array:
 ;;
  mov widebp,widesi
  mov widesi,[widesi*wideword_sz+CR3_array]
  


 ;Check if there is already a valid page table
 ;address at the specified page directory entry:
 ;;
 ;Inputs:
 ;      WIDESI -- Virtual address to modify
 ;
 ;Outputs:
 ;       WIDEAX -- Byte offset into a page directory
 ;;
 push wideax
  call OPCODE__CPU_x86_32_addr2pagedirent
 ;Unused entries MUST be 0, swapped out pages must have Present=0
 ;;
  mov widecx,wideax  ;Save offset into page directory
  add widecx,widesi  ;Add CR0 address
 pop wideax
  test dword[widecx],CPU_x86_32_Paging_Bit0_Present_TRUE
  jnz .notemptypagedirent

     ;If the page directory entry is not empty,
     ;we just set the page table:
     ;;     

  jmp .notemptypagedirent_end
  align wideword_sz
  .notemptypagedirent:
  mov widesi,widebp   ;Restore directory index 0-N


 ;If the page directory entry is empty, reserve a new page for it
 ;in the physical bitmap getting its address:
 ;;
 ;Outputs:
 ;       WIDEAX -- Newly-reserved 4K page address ([KERNEL_PAGE_BITMAP] on error
 ;                 as the bitmap memory region can never be reassigned).
 ;;
  mov widebx,wideax   ;Save original attributes
  and widebx,0xFFFF
  call OPCODE__data_bitmap__get_free_physical_memory_address
printdbg_str_hexnum vws2rf23str,"A Newly reserved address for new page table (stored in pagedir): ",0,wideax
  or wideax,widebx   ;Combine attributes with physical address

printdbg_str_hexnum vwf2rf23str,"A Combined specified physical address/attributes for new page table (stored in pagedir): ",0,wideax




 ;Now that we have marked a new physical data page
 ;as used, put it into the page directory entry:
 ;
 ;;
 ;Inputs:
 ;      WIDEDX -- CR3 array offset address
 ;      WIDESI -- Page directory entry to modify
 ;      WIDEAX -- Physical address to point to and attribute bits
 ;;
 ;push widesi ;CR3 index
 ;push wideax ;attributes and physical address
 ;push widedi ;target virtual address
  mov widedx,widesi
  mov widesi,widedi
  call OPCODE__CPU_x86_32_map_physical_pagedir_entry


;printdbg_str_hexnum vwf2rk23str,"A Combined specified physical address/attributes for new page table: ",0,wideax



 ;Now remap an exploration page to manipulate
 ;page table entries:
 ;
 ;
 ;
 ;;
 ;Inputs:
 ;      WIDEDX -- CR3 array offset address
 ;      WIDESI -- Virtual address to modify
 ;      WIDEDI -- New physical address to point to
 ;;
  ;pop widedi ;target virtual address
  ;pop wideax ;attributes and physical address
  ;pop widesi ;CR3 index
  ;push widesi ;CR3 index
  ;push wideax ;attributes and physical address
  ;push widedi ;target virtual address
  ;mov widedx,widesi
  ;mov widesi,kernel_pagedir_visor_page_0
  ;mov widedi,wideax
  ;call OPCODE__CPU_x86_32_remap_physical_page_address
  ;;xchg widesi,widedi






 ;pop widedi ;target virtual address
 ;pop wideax ;attributes and physical address
 ;pop widesi ;CR3 index

 ;pop wideax   ;privilege/target physical
 ;pop widedi   ;cr3 index
 ;pop widesi   ;target virtual
 align wideword_sz
 .notemptypagedirent_end:
 ;mov widesi,widebp   ;Restore directory index 0-N


 ;Just remap the page table:
 ;;

 ;Inputs:
 ;      WIDEDX -- CR3 array offset address
 ;      WIDESI -- Virtual address to modify
 ;      WIDEDI -- New physical address to point to
 ;;
 ;push widesi ;CR3 index
 ;push wideax ;attributes and physical data page address
 ;push widedi ;target virtual address


 ;Optimize to pop/push with final registers:
 ;;
  pop wideax   ;privilege/target physical
  pop widedi   ;cr3 index
  pop widesi   ;target virtual

  push widesi  ;target virtual
  push widedi  ;cr3 index
  push wideax  ;privilege/target physical

 ;mov widedx,widesi
 ;mov widesi,widedi
 ;mov widedi,wideax  
  mov widedx,widesi
  mov widesi,widedi
  mov widedi,wideax  
;      WIDESI -- Index in the CR3 array 0 to N.
;      WIDEAX -- Privilege/type flags and [UNUSED IN THIS FUNCTION]manual target physical address.
;      WIDEDI -- Target virtual address (0 for identity mapping)
  
  call OPCODE__CPU_x86_32_remap_physical_page_address
;  call OPCODE__CPU_x86_32_set_physical_page_attributes

printdbg_str_hexnum vwf2rk2Sstr,"DX: ",0,widedx
printdbg_str_hexnum vwf2rk2Tstr,"SI: ",0,widesi
printdbg_str_hexnum vwf2rk2bstr,"DI: ",0,widedi
;cli
;hlt






 align wideword_sz
 .end:



 ;pop wideax
 ;call OPCODE__CPU_Restore_Default_Paging
 call OPCODE__CPU_Enable_Default_Paging


mov widesi,1048576*100
mov byte[widesi],'a'
printdbg_str_hexnum vwf2rk23str,"A Test write at new page: ",0,[widesi]


 add widesp,wideword_sz       ;discard WIDEAX as we will return it
 ;pop wideax
 pop widedi
 pop widesi

 pop widebp
 pop widedx
 pop widecx
 pop widebx
 popfwide
retwide






;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions
;;;;END:  32-bit paging functions































































































































;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







;Detect how much physical memory we have installed
;(it will also help us test the stability/predictability
;of a given hardware, which should not lock up).
;
;This is the first function that needs timing and
;that is important for detecting all 32-bit memory
;in all systems, so it's better to leave it
;after setting the PIT timer interrupt up.
;;
 call OPCODE__detect_32bit_memory_by_pages    ;value in EAX



;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization
;;;;INIT: Physical bitmapped memory initialization

 call OPCODE__memory__initialize_system_bitmapped_memory


;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization
;;;;END:  Physical bitmapped memory initialization











;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization
;;;;INIT: 32-bit Paging initialization


cli



;push widedi;0
;push wideax;1
;push widecx;2





;Generate an empty page directory
;in a place we have proven to be empty
;and, if we have more than 16MB, put as much
;as we can of the paging structures there:
;;
 ;mov wideax,8
 ;mov wideax,3
; mov wideax,2
; call kalloc_Append_Kernel_Pages
; mov [CR3_array],wideax
 ;mov wideax,1048576*16
 ;Inputs:
 ;       WIDEAX -- Value to convert
 ;       WIDESI -- Temporary buffer for resulting string
 ;;
  mov wideax,[_KERN_END]
  mov widesi,emptystr+64
  call console_kprint_uint32_16

 ;Inputs:
 ;       WIDESI -- String to print
 ;;
  mov widesi,spcstr
  call console_kprint_visible


;sti
;call exittodos  ;Lockup point to debug


;Test if our bitmap-page-reserving functions work well
;to free and reserve:
;;
; mov widesi,[KERNEL_PAGE_BITMAP]
 call OPCODE__data_bitmap__get_free_physical_memory_address
 call OPCODE__data_bitmap__get_free_physical_memory_address
 call OPCODE__data_bitmap__get_free_physical_memory_address
 call OPCODE__data_bitmap__get_free_physical_memory_address
 call OPCODE__data_bitmap__free_physical_memory_address
 sub wideax,4096
 call OPCODE__data_bitmap__free_physical_memory_address
 sub wideax,4096
 call OPCODE__data_bitmap__free_physical_memory_address
 sub wideax,4096
 call OPCODE__data_bitmap__free_physical_memory_address

 ;This value in WIDEAX will be used for the
 ;page directory:
 ;;
  call OPCODE__data_bitmap__get_free_physical_memory_address



 ;Inputs:
 ;       WIDEAX -- Value to convert
 ;       WIDESI -- Temporary buffer for resulting string
 ;;
  ;mov wideax,[_KERN_END]
  mov widesi,emptystr+64
  call console_kprint_uint32_16


;printdbg_str_hexnum rge4t43hgr4zgwr54,"KERN_END: ",0,[_KERN_END]
;ERROR: This macro seems to alter WIDEAX because
;       the comparison below fails as if it was modified.


 ;sub wideax,4096
 cmp wideax,[_KERN_END]   ;At this point the value of our page has to be at [KERN_END],
 je .nobitm               ;right after the memory accounted in the runtime kernel image
                          ;(we need to test that paging structures themselves can work
                          ;in an unmapped region).

printdbg_str_hexnum rge4t43hgr4rgwr54,"WIDEAX: ",0,wideax
printdbg_str_hexnum rge4t43hgr4zgwr54,"KERN_END: ",0,[_KERN_END]


;  cli
;  hlt
 
 .nobitm:
;cli
;hlt




 mov wideax,[_KERN_END]
 mov [CR3_array],wideax

; mov widedi,(1048576*20)+kernel_page_window  ;Make this function dynamically get
 mov widedi,wideax      ;Make this function dynamically get
                        ;a free page, but for that we need to
                        ;detect memory by different methods
                        ;before loading the kernel and record
                        ;the memory used by the kernel with a
                        ;memory management function set that
                        ;tell us if a given page is in a reserved
                        ;area or not. That's not the function
                        ;of paging itself but of basic memory detection,
                        ;and reserved areas defined by the PC (BIOS,
                        ;video, DMA, PCI, the first Megabyte, memory holes...).
                        ;It must record the area in an element with
                        ;value 0 (NULL) in the CR3 array, and an
                        ;index variable to indicate the currently active
                        ;CR3. Element 0 should always be the root CR3.
 call OPCODE__CPU_generate_4KB_empty_page_directory  ;Take into account reserved regions from some subsystem and add complexity to it gradually
 ;Returns nothing




;The page table also needs to be outside the
;mapped kernel image, at an unmapped address,
;and still work in pure hardware:
;;

;Generate an entry in the page directory
;to a page table for the first 2 or 4 Megabytes:
;;
; mov wideax,(1048576*20)+kernel_page_window+(4096*1)

 ;;add wideax,(4096*1)
 call OPCODE__data_bitmap__get_free_physical_memory_address


 ;mov wideax,1048576*17
 ;This value in WIDEAX will be used for the
 ;first page table:
 ;;
  ;call OPCODE__data_bitmap__get_free_physical_memory_address
 or wideword[widedi],_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_TRUE
 or wideword[widedi],wideax



;Generate the addresses for the first megabyte
;and for the kernel in the first page table:
;;
 mov widedi,wideax
; mov widedi,(1048576*20)+kernel_page_window+(4096*1)   ;Address of page table
; add widedi,(4096*1)   ;Address of page table
 ;Prepare as many entries
 ;as we are currently using
 ;in memory:
 ;;
  mov widecx,[KERNEL_PAGES]
  add widecx,256   ;all entries used from the first MB to the end of the kernel
;  add widecx,1024   ;all entries used from the first MB to the end of the kernel
  xor wideax,wideax   ;Current address
  or wideax,_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_TRUE|_FLAG_x86_32_pageDirectoryEntry_Bit1_ReadWrite|_FLAG_x86_32_pageDirectoryEntry_Bit2_SupervisorLevel
  align wideword_sz
  .pgtbl0:
    stosd
    add wideax,4096
  loop .pgtbl0



;Map contiguous memory portions for video RAM,
;for the kernel, and the page directory structures.
;If it doesn't lock;
;;
; mov widesi,0xB8000   ;Video RAM
; mov widecx,1         ;1 contiguous page
; call OPCODE__CPU_raw_paging_allocate_contiguous_physical_4KB_pages

; mov widesi,1048576          ;Kernel image
; mov widecx,[KERNEL_PAGES]   ;current number of kernel pages
; call OPCODE__CPU_raw_paging_allocate_contiguous_physical_4KB_pages



;This will map the structures pointed by
;the currently loaded CR3 value as the
;root page directory:
;;
; call OPCODE__CPU_raw_paging__physically_map_structures



;Load the CR3 value:
;;
;Inputs:
;      WIDEDI -- Page directory to load into CR3
;
;      WIDESI -- CR3 values array base address
;      WIDECX -- Number of elements in the CR3 values array
;                (0 if storing it into the system CR3 array isn't desired,
;                for example to return from a single-tasking fast task
;                created by the kernel)
;
;Outputs:
;        WIDEAX -- Offset of the CR3 values array where
;                  the CR3 array was stored.
; mov widedi,(1048576*20)+kernel_page_window
 mov widedi,[CR3_array]
 mov widesi,CR3_array
 mov widecx,0
 call OPCODE__CPU_load_CR3_paging









;pop widecx;2
;pop wideax;1
;pop widedi;0

;cli
;hlt




 ;Enable default 32-bit paging:
 ;;
  call OPCODE__CPU_Enable_Default_Paging


sti

;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization
;;;;END:  32-bit Paging initialization









;Mark the address up to this point as the
;start of application and non-core kernel code
;since at this point all critical things should
;have already been added to the running kernel image:
;;
 mov wideax,[_KERN_END]
 mov wideword[APP_ADDRESS_START],wideax








;Cache the current CR0 value:
;;
 mov wideax,cr0
 mov [CR0_cache],wideax








;Test to identity-map Megabyte number 100 with our maing paging functions:
;;

;Inputs:
;      WIDESI -- Index in the CR3 array 0 to N.
;      WIDEAX -- Privilege/type flags and target physical address.
;      WIDEDI -- Target virtual address (0 for identity mapping)
;
;
;Outputs:
;       WIDEAX -- New virtual page address
;
;;
 mov widesi,0
 mov wideax,(1048576*100)|(_FLAG_x86_32_pageDirectoryEntry_Bit0_Present_TRUE|_FLAG_x86_32_pageDirectoryEntry_Bit1_ReadWrite|_FLAG_x86_32_pageDirectoryEntry_Bit2_UserLevel)
 mov widedi,1048576*100
 call OPCODE__CPU_x86_32_raw_paging_allocate_physical_4KB_page



























































































;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data
;;;;INIT: Protected mode data


align wideword_sz
CR0_cache ww 0



;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data
;;;;END:  Protected mode data







 align wideword_sz
 _KERN_END ww  KERNEL_BASE+KERN_SZ

 align 65536,db 0     ;To keep all physical addresses aligned to 4-page blocks
                      ;and virtual addresses to 16-page blocks.










KERN_END:
KERN_SZ equ (KERN_END-KERN_START)
